/*----------------------------------------------------------------------------*/
/* Teknisa Sistemas Integrados                                                */
/* 2870_PEDSTPO_GRAVA_COMPOSICAO_BDL.SQL                                      */
/* Autor: Diego Gonalves                                                     */
/* Data: 27/01/2010                                                           */
/* Descrio:                                                                 */
/*  Procedure para gravar os produtos da composio na tabela TRAB_SUGCOMPRA  */
/*----------------------------------------------------------------------------*/
create or replace
PROCEDURE GRAVA_COMPOSICAO_BDL (P_CDFILIAL         IN VARCHAR2, 
                                P_CDPRODUTO        IN VARCHAR2, 
                                P_QTPRODUTO        IN FLOAT, 
                                P_DATAATUAL        IN DATE, 
                                P_NRCHAVE          IN VARCHAR2, 
                                P_DTENTINI         IN DATE, 
                                P_DTENTFIN         IN DATE,
                                P_DTPEDFIN         IN DATE,
                                P_DTPEDINI         IN DATE,
                                P_CDFILIDEST       IN VARCHAR2,
                                P_CDCLIENTE        IN VARCHAR2,
                                P_IDSITITEMPED     IN VARCHAR2) 
IS 
     
    V_COTLOCAL        DOUBLE PRECISION; 
    V_COTPADRAO       DOUBLE PRECISION;     
    V_NRITESUGCOMP    VARCHAR2(10); 
    V_COUNTNRITE      DOUBLE PRECISION; 
    V_QTCOMPRA        DOUBLE PRECISION; 
    V_QTPEDIDO        DOUBLE PRECISION; 
    V_QTESTSEGU       DOUBLE PRECISION; 
    V_QTPREVICOMP     DOUBLE PRECISION; 
    V_QTSOLICITA      DOUBLE PRECISION; 
    V_QTESTPRODUTO    DOUBLE PRECISION; 
    V_CDPRODUTO       VARCHAR2(10); 
    V_CDARVPROD       VARCHAR2(10);
    V_QTSAIDAANT      FLOAT;
BEGIN 
   SELECT COUNT(*) 
     INTO V_COTLOCAL 
     FROM ROTFABLOCAL R 
    WHERE (R.CDFILIAL  = P_CDFILIAL   ) 
      AND (R.CDPRODUTO = P_CDPRODUTO ); 
   IF V_COTLOCAL > 0 THEN 
       
      FOR C_COMPLOCAL IN (SELECT R.CDPRODUTO, R.CDSUBPRODLOC, R.QTSUBPRODLOC 
                            FROM ROTFABLOCAL R 
                           WHERE (R.CDFILIAL  = P_CDFILIAL   ) 
                             AND (R.CDPRODUTO = P_CDPRODUTO ) 
                           ORDER BY R.NRSEQPRODLOC)LOOP 
         GRAVA_COMPOSICAO_BDL (P_CDFILIAL, C_COMPLOCAL.CDSUBPRODLOC, (C_COMPLOCAL.QTSUBPRODLOC * P_QTPRODUTO), P_DATAATUAL, 
                               P_NRCHAVE, P_DTENTINI, P_DTENTFIN, P_DTPEDFIN, P_DTPEDINI, P_CDFILIDEST, P_CDCLIENTE, P_IDSITITEMPED); 
      END LOOP; 
   ELSE 
      SELECT COUNT(*) 
        INTO V_COTPADRAO 
        FROM ROTFABRICA R 
       WHERE (R.CDPRODUTO    = P_CDPRODUTO); 
      IF V_COTPADRAO > 0 THEN 
          
         FOR C_COMPPADRAO IN (SELECT R.CDPRODUTO, R.CDSUBPRODUTO, R.QTSUBPRODROT 
                                FROM ROTFABRICA R 
                               WHERE (R.CDPRODUTO    = P_CDPRODUTO) 
                               ORDER BY R.CDPRODUTO)LOOP 
             GRAVA_COMPOSICAO_BDL (P_CDFILIAL, C_COMPPADRAO.CDSUBPRODUTO, (C_COMPPADRAO.QTSUBPRODROT * P_QTPRODUTO), P_DATAATUAL, 
                                  P_NRCHAVE, P_DTENTINI, P_DTENTFIN, P_DTPEDFIN, P_DTPEDINI, P_CDFILIDEST, P_CDCLIENTE, P_IDSITITEMPED); 
         END LOOP; 
      ELSE 
         BEGIN 
            SELECT MAX(NRITESUGCOMP), COUNT(NRITESUGCOMP) 
              INTO V_NRITESUGCOMP,    V_COUNTNRITE 
              FROM TRAB_SUGCOMPRA 
             WHERE CDFILSUGCOMP = P_CDFILIAL 
               AND NRSUGCOMPRA  = P_NRCHAVE; 
         EXCEPTION 
            WHEN NO_DATA_FOUND THEN 
               V_NRITESUGCOMP := 0; 
               V_COUNTNRITE := 0; 
         END; 
         BEGIN 
         SELECT SUM(NVL((SELECT DISTINCT SUM(IT.QTITEMPED - IT.QTEXPITEMPED) 
                           FROM ITEMPEDIDO IT, PEDIDO P
                          WHERE IT.CDPRODUTO = P_CDPRODUTO  
                            AND INSTR(P_IDSITITEMPED, IT.IDSITITEMPED) > 0
                            AND IT.CDFILIAL = P_CDFILIAL
                            AND IT.CDFILIAL = P.CDFILIAL
                            AND IT.NRPEDIDO = P.NRPEDIDO                                
                            AND ((TRUNC(IT.DTENTITPED)BETWEEN P_DTENTINI  AND P_DTENTFIN)OR((P_DTENTINI IS NULL) AND(P_DTENTFIN IS NULL)))
                            AND P.IDSITPEDIDO IN('1','2','3','6')                                
                            AND ((P.DTPEDIDO BETWEEN P_DTPEDINI  AND P_DTPEDFIN)OR((P_DTPEDINI IS NULL) AND(P_DTPEDFIN IS NULL)))
                            AND ((P_CDCLIENTE IS NULL)OR(INSTR(P_CDCLIENTE, P.CDCLIENTE)>0))
                            AND ((P_CDFILIDEST IS NULL)OR( INSTR(P_CDFILIDEST, P.CDFILIALPED)>0))
                            AND NOT EXISTS(SELECT K.NRPEDIDO
                                             FROM PEDIDOP K
                                            WHERE K.CDFILIAL = IT.CDFILIAL 
                                              AND K.NRPEDIDO = IT.NRPEDIDO 
                                              AND K.NRITEMPED = IT.NRITEMPED)), 0)) AS QTPEDIDO,
                    SUM(NVL((SELECT QTESTOSEGU 
                               FROM ESTOSEGU 
                              WHERE CDFILIAL = P_CDFILIAL
                                AND CDPRODESTO = U.CDPRODESTO), 0)) AS QTESTSEGU, 
                    SUM(NVL((SELECT SUM(NVL(QTPREVCOMP,0)) 
                               FROM ITPREVCOMP C 
                              WHERE C.IDSTITPRCOMP = ('A')      
                                AND ((C.DTENTPRECOMP BETWEEN P_DTENTINI  AND P_DTENTFIN)OR((P_DTENTINI IS NULL) AND(P_DTENTFIN IS NULL)))
                                AND P_CDFILIAL   = C.CDFILIAL  
                                AND P_CDPRODUTO  = C.CDPRODUTO),0)) AS QTPREVICOMP, 
                    SUM(NVL((SELECT SUM(NVL(IL.QTSOLIPROD,0)) 
                               FROM SOLICITA S, ITEMSOLI IL
                              WHERE P_CDFILIAL  = IL.CDFILSOLI 
                                AND P_CDPRODUTO = IL.CDPRODUTO 
                                AND (S.IDBAIXASOL IS NULL)          
                                AND ((IL.DTPROGENTR BETWEEN P_DTENTINI  AND P_DTENTFIN)OR((P_DTENTINI IS NULL) AND(P_DTENTFIN IS NULL)))
                                AND IL.CDFILSOLI  = S.CDFILSOLI
                                AND IL.CDFILLAN   = S.CDFILLANCA
                                AND  IL.NRSOLICMP  = S.NRSOLICMP ),0)) AS QTSOLICITA,
                        
                    SUM(NVL((SELECT SUM(NVL(QTTOTALESTOQ,0))* NVL(U.VRFATOCONV, 1) 
                         FROM POSESTATU PA 
                        WHERE P_CDFILIAL   = PA.CDFILIAL  
                          AND U.CDPRODUTO  = PA.CDPRODUTO 
                          AND PA.CDALMOXARIFE =  BUSCA_ALMOX(P_CDFILIAL, '', U.CDPRODUTO)
                          AND PA.CDLOCALESTOQ =  BUSCA_LOCAL(P_CDFILIAL, '', U.CDPRODUTO )),0)) AS QTESTPRODUTO, 
                    U.CDPRODUTO, U.CDARVPROD 
              INTO V_QTPEDIDO, V_QTESTSEGU, V_QTPREVICOMP, V_QTSOLICITA, V_QTESTPRODUTO, V_CDPRODUTO, V_CDARVPROD 
              FROM PRODUTO U 
             WHERE U.CDPRODUTO = P_CDPRODUTO              
             group by U.CDPRODUTO, U.CDARVPROD; 
         EXCEPTION 
            WHEN NO_DATA_FOUND THEN 
               V_QTPEDIDO := NULL; 
               V_QTESTSEGU := 0; 
               V_QTPREVICOMP := 0; 
               V_QTSOLICITA := 0; 
               V_QTESTPRODUTO := 0; 
               V_CDPRODUTO := NULL; 
               V_CDARVPROD := NULL; 
         END; 
         V_QTCOMPRA  := V_QTESTPRODUTO + V_QTSOLICITA - ( NVL(V_QTPEDIDO, P_QTPRODUTO)  + V_QTESTSEGU + V_QTPREVICOMP); 
         IF V_QTCOMPRA > 0 THEN 
            V_QTCOMPRA := 0; 
         ELSE 
            V_QTCOMPRA := V_QTCOMPRA * (-1); 
         END IF; 
          
         UPDATE TRAB_SUGCOMPRA 
            SET QTCOMPRA     = QTCOMPRA + V_QTCOMPRA, 
                QTSAIDAANT01 = QTSAIDAANT01 + NVL(V_QTPEDIDO, P_QTPRODUTO), 
                QTSAIDAANT02 = QTSAIDAANT02 + V_QTESTPRODUTO, 
                QTSAIDAANT03 = QTSAIDAANT03 + V_QTESTSEGU, 
                QTSAIDAATUAL = QTSAIDAATUAL + V_QTSOLICITA, 
                QTMEDIAMES   = QTMEDIAMES + V_QTPREVICOMP 
          WHERE CDFILSUGCOMP = P_CDFILIAL 
            AND NRSUGCOMPRA  = P_NRCHAVE 
            AND CDPROSUGCOMP = P_CDPRODUTO; 
         IF SQL%NOTFOUND THEN  
        
        IF NVL(V_QTPEDIDO, P_QTPRODUTO) > 0 THEN
           V_QTSAIDAANT := NVL(V_QTPEDIDO, P_QTPRODUTO);
        ELSE
           V_QTSAIDAANT := 0;
        END IF;
       
         INSERT INTO TRAB_SUGCOMPRA 
                (CDFILSUGCOMP, NRSUGCOMPRA, CDPROSUGCOMP, DTREFSUGCOMP, QTCOMPRA, 
                QTSAIDAANT01, QTSAIDAANT02, QTSAIDAANT03, QTSAIDAATUAL, QTMEDIAMES, NRITESUGCOMP) 
         VALUES 
                (P_CDFILIAL , P_NRCHAVE, P_CDPRODUTO, SYSDATE, V_QTCOMPRA, 
                V_QTSAIDAANT, V_QTESTPRODUTO, V_QTESTSEGU, V_QTSOLICITA, V_QTPREVICOMP, LPAD(TO_CHAR(NVL(TO_NUMBER(V_NRITESUGCOMP), V_COUNTNRITE) + 1), 10, '0')); 
         END IF; 
      END IF; 
   END IF; 
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GRAVA_COMPOSICAO_BDL','5.09.014'); END;
/